/*****************************************************************************
 *                                                                           *
 *   Copyright (C) 2005 by Chazal Francois             <neptune3k@free.fr>   *
 *                 2007 by Andrey Skvortsov            <stingo000@yahoo.ca>  *
 *                 based on Quadconsole 2.0.1 code by                        *
 *                 Simon Perreault                                           *
 *                                                                           *
 *                     =========  GPL Licence  =========                     *
 *    This program is free software; you can redistribute it and/or modify   *
 *   it under the terms of the  GNU General Public License as published by   *
 *   the  Free  Software  Foundation ; either version 2 of the License, or   *
 *   (at your option) any later version.                                     *
 *                                                                           *
 *****************************************************************************/

#ifndef SHELL_SESSION_H
# define SHELL_SESSION_H

//== INCLUDE REQUIREMENTS ===================================================//

/*
** C libraries */
#include <stdlib.h>

/*
** Qt libraries */
#include <qobject.h>
#include <qwidget.h>
#include <qaction.h>

/*
** KDE libraries */
#include <klibloader.h>
#include <kparts/part.h>
#include <kde_terminal_interface.h>

#include <vector>

//== DEFINE CLASS & DATATYPES ===============================================//

/*
** Class 'ShellSession' creates a shell session from konsole kpart
********************************************************************/
class KLibFactory;
class QGridLayout;

//From Quadkonsole (not used in this version)
// class MouseMoveFilter : public QObject
// {
//     Q_OBJECT
// public:
//     MouseMoveFilter( QObject* parent ): QObject(parent){};
// public:
//     bool eventFilter( QObject* o, QEvent* e )
//       {
//       if ( e->type() == QEvent::MouseMove) {           
//             QWidget* w = dynamic_cast<QWidget*>(o);
//             if(w)w->setFocus();
//             return QObject::eventFilter(o, e);
//       }
//        else {
//              // standard event processing
//              return QObject::eventFilter(o, e);
//        }
// 
//       return true;
//       };
// 
// };


class ShellSession : public QObject
{
    Q_OBJECT

public:

    //-- PRIVATE ATTRIBUTES ---------------------------------------------//

    KParts::Part *      session_part;        
    QWidget *           session_widget;  

    QAction* mgoRight;
    QAction* mgoLeft;
    QAction* mgoDown;
    QAction* mgoUp;

public:

    //-- CONSTRUCTORS AND DESTRUCTORS -----------------------------------//

    ShellSession(QWidget * parent = 0, int nlay = 0, const char * name = 0);
    virtual ~ShellSession();

    
    //-- PUBLIC METHODS -------------------------------------------------//
   void FocusSession();
   void KeepPartsSlectedId();
   int PartSelected();

protected:
    virtual void customEvent( QCustomEvent* e );

//======================================================================
private slots:
     void partDestroyed();
     void focusKonsoleRight();
     void focusKonsoleLeft();
     void focusKonsoleUp();
     void focusKonsoleDown();
     
public:
     typedef std::vector<KParts::Part*> PartVector;
      PartVector mKonsoleParts;
private:
    KParts::Part* createPart( int row, int column, QWidget* wsession );   

//    MouseMoveFilter* mFilter;
    KLibFactory* mFactory;
    QGridLayout* mLayout;

    int part_selected_id;

    
//======================================================================


public slots:

    //-- PUBLIC SLOTS ---------------------------------------------------//

 //  void    slotDestroySession();
  //  void    slotUpdateSessionTitle(const QString &);

signals:
    //-- SIGNALS DEFINITION ---------------------------------------------//

    void    titleUpdated();
};

#endif /* SHELL_SESSION_H */
